using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using Syntriax.Engine.Core;
using Syntriax.Engine.Integration.MonoGame;

namespace Pong.Behaviours;

public class Label : Behaviour2D, IDrawableSprite
{
    public SpriteFont? Font { get; set; } = null;
    public int Size { get; set; } = 16;
    public string Text { get; set; } = string.Empty;

    public void Draw(ISpriteBatch spriteBatch)
    {
        if (Font is null)
            return;

        spriteBatch.DrawString(Font, Text, Transform.Position, Color.White, Transform.Rotation, Vector2D.One * .5f, Transform.Scale.Magnitude, SpriteEffects.None, 0f);
    }

    public Label() { }
    public Label(SpriteFont font) => Font = font;
}
